@import 'src/style/includes/sass_vars_and_mixins.module.scss';


$group-padding: 0.4em;

.wrapper {
  position: relative;
  display: inline-flex;
  align-items: center;

  max-width: 100%;
  font-size: var(--font-size-m);

  &.l {
    font-size: var(--font-size-l);
  }

  &.s {
    font-size: var(--font-size-s);
  }

  &.icon {
    align-self: center;
  }

  &.isOpen.searchable {
    .button {
      opacity: 0;
    }
  }

  &.expand {
    @include smaller-than-xs {
      display: flex;

      .button,
      .segments {
        max-width: 65%;
        flex-grow: 1;
      }

      .segments {
        display: flex;
      }
    }
  }
}

.inputWrapper {
  position: relative;
}

.input {
  position: absolute;
  left: 0;
  top: 0;
  right: 0;
  height: 100%;
  background: white;
  padding-left: 0.6em;

  &::placeholder {
    color: var(--color-text-weaker);
  }
}

.label {
  margin-right: var(--space-xxs);
  display: inline-block;
  white-space: nowrap;
  color: var(--color-text-weaker);
}

.wrapper .tray {
  position: fixed;
  z-index: 999;
  box-shadow: 0 0 var(--space-m) rgba(0, 0, 0, 0.1);
  background: white;
  display: flex;
  flex-direction: column;
  overflow: hidden;
  padding: $group-padding 0;
  max-height: 50vh;
  overflow-y: scroll;
  -ms-overflow-style: none; /* for Internet Explorer, Edge */
  scrollbar-width: none; /* for Firefox */
  margin: 0;
  margin-top: var(--space-xxs);
  transform: translateY(0);
  font-size: var(--font-size-m);

  // Overwrite default ul styles
  ul {
    padding: 0;
    margin-bottom: 0;
  }

  li {
    list-style: none;
  }

  &.full {
    display: block;
    columns: 200px;
    max-height: none;
    padding: var(--space-m);
    padding-top: var(--space-l);

    .selectItemContent,
    .selectGroupName {
      white-space: normal;
    }

    .selectGroup {
      border-bottom: none;
      margin-bottom: var(--space-l);
    }

    .selectGroupName {
      font-size: var(--font-size-s);
    }

    ul {
      li {
        break-inside: avoid;
      }
    }
  }

  // Overwrite default li styles, but keep specific item/group styling
  li:not(.selectItem):not(.selectGroup) {
    padding: 0;
    margin: 0;
  }

  &[aria-hidden='true'] {
    visibility: hidden;
    opacity: 0;
    transform: translateY(-1em);
    //transition: none;
  }

  &::-webkit-scrollbar {
    display: none;
  }

  @include smaller-than-s {
    &.full {
      max-height: 80vh;
      columns: unset;
      padding-left: 0;
      padding-right: 0;
    }
  }
}

.selectItems {
  margin: 0;
  padding: 0;
}

.selectItem {
  padding: 0.4em var(--space-s);
  color: var(--color-text-base);
  font-size: 1em;
  cursor: pointer;
  list-style: none;
  display: flex;
  justify-content: space-between;
  align-items: center;
  line-height: 1.3em;
  margin: 0;
  list-style: none;
  break-inside: avoid;
  font-weight: 400;

  &.isHighlighted {
    background-color: var(--color-brand-weaker);
    color: var(--color-brand-base);
  }

  &.isSelected {
    color: var(--color-brand-base);
    font-weight: 600;
  }

  &.iconBefore {
    .selectItemIcon {
      margin-right: 0.3em;
    }
  }

  &.iconAfter {
    .selectItemIcon {
      margin-left: 0.3em;
      margin-right: -0.4em;
    }
  }

  &[disabled],
  &.disabled {
    pointer-events: none;
    opacity: .6;
  }

  a {
    text-decoration: none;
  }
}

.selectItemContent {
  display: inline-flex;
  align-items: center;
  white-space: nowrap;
  text-overflow: ellipsis;
  overflow: hidden;
  width: 100%;
  color: var(--color-brand-base);
}

.selectItemIcon {
  display: inline-block;
  font-size: 16px;
}

.selectGroup {
  border-bottom: 1px solid var(--color-background-weakest);
  list-style: none;
  padding: $group-padding 0;
  margin-bottom: $group-padding;
  margin-top: -$group-padding;

  &:first-child {
    padding-top: 0;
    margin-top: 0;
  }

  &:last-child {
    border-bottom: none;
    margin-bottom: 0;
    padding-bottom: 0;
  }
}

.selectGroupName {
  display: inline-block;
  padding-left: var(--space-s);
  margin-bottom: -5px;
  font-size: 0.8em;
  font-weight: 600;
  white-space: nowrap;
}

.emptyListText {
  color: var(--color-text-weaker);
}

// SEGMENTED CONTROL

.segment {
  justify-content: center;
  flex-grow: 1;
}

.separateRight {
  margin-right: 1.5em;
  position: relative;

  &:after {
    content: '';
    display: block;
    position: absolute;
    right: 1px;
    top: 0.6em;
    bottom: 0.2em;
    border-right: 1px solid var(--color-brand-weakest);
  }
}

// TABS / NAVBAR

.navBarWrapper,
.tabBarWrapper {
  max-width: 100%;

  &::-webkit-scrollbar {
    display: none;
  }

  @include smaller-than-s {
    overflow: scroll;
    -ms-overflow-style: none; /* for Internet Explorer, Edge */
    scrollbar-width: none; /* for Firefox */
    &.overflowLeft {
      box-shadow: inset 3px 0 0 rgba(black, 0.15);
    }

    &.overflowRight {
      box-shadow: inset -3px 0 0 rgba(black, 0.15);
    }

    &.overflowRight.overflowLeft {
      box-shadow: inset -3px 0 0 rgba(black, 0.15), inset 3px 0 0 rgba(black, 0.15);
    }
  }
}

.tabBarWrapper {
  border-bottom: 2px solid var(--color-background-weakest);
  // a for specificity to overwrite button
  button.tab {
    padding-right: 0;
    padding-left: 0.3em;
    padding-top: 1.5em;
    padding-bottom: 0.8em;
    margin-right: var(--space-l);
    font-weight: 400;
  }
}


.tabWrapper {
  margin: 0;
  margin-right: var(--space-l);

  @include smaller-than-s {
      margin-right: var(--space-m);
  }
}

.tabIcon {
  font-size: 1.2em;
}

// STATIC VALUES
.static {
  font-size: var(--font-size-s);
  display: inline-flex;
  align-items: baseline;
}

.staticLabel {
  display: inline-block;
  margin-right: var(--space-xxs);
}
